var _notechanged = false;
var _notetitle = null;

function _notesinit (e) {
	var table = document.getElementsByTagName('table')[0];
	var trs = table.getElementsByTagName('tr');
	for (var i=1; i < trs.length; i++) {
		trs[i].addEvent('click', _opennote);
//		trs[i].addEventListener('click', _opennote, ,false);
	}
	
	document.content.text.addEvent('change', function () { _notechanged = true; });
//	document.content.text.addEventListener('change', function () { _notechanged = true; }, ,false);	

	document.getElementById('newbutton').addEvent('click', _newnote);
//	document.getElementById('newbutton').addEventListener('click', _newnote, ,false);
	document.getElementById('savebutton').addEvent('click', _performNoteSave);
//	document.getElementById('savebutton').addEventListener('click', _performNoteSave, ,false);
	document.getElementById('helpbutton').addEvent('click', function () { window.location="/help/pages/notes.html";});
//	document.getElementById('helpbutton').addEventListener('click', function () { window.location="/help/pages/notes.html";}, ,false);
	
	// Stuff for dealing with saves
	var p = document.getElementById('saved');
	if (p.innerHTML.length > 0)
	{
		p.innerHTML = p.innerHTML + " has been successfully saved.";
		p.style.display = "block";
		window.setTimeout(function() { p.fadeout(); }, 3000);
	}
	
	if (navigator.userAgent.indexOf('iPhone') > -1) 
	{
		for (var i=0; i < trs.length; i++) {
			var items = trs[i].getElementsByTagName('td');
			if (!items.length) items = trs[i].getElementsByTagName('th');
			while (items[2]) trs[i].removeChild(items[2]);
		};
	}
}

function _newnote (e) {
	var name = window.prompt("Enter the name for your new note:", '');
	if (name == null) return;
	document.title = name;
	document.content.text.value = 'Write about ' + name + ' here.\n' + name + ' will appear in the files list after it has been saved.';
	document.content.filename.value = name;
	NotesResizeTextArea();
}

function _opennote (e) {
	_notetitle = this.getElementsByTagName('td')[0].innerHTML;
	
	var t = document.getElementsByTagName('table')[0];
	var trs = t.getElementsByTagName('tr');
	for (var i=0; i < trs.length; i++) {
		trs[i].className = '';
		trs[i].style.background = '';
	};
	this.className = 'selected';
	t.stripe();
	

	if (_notechanged == true) { // If there is an edited document
		_showUnsavedNoteWarning();
		return;
	}
	_loadnote();
}

function _showUnsavedNoteWarning () {
	var alert = new Alert('Save changes?', 'The current document has been edited.  Would you like to save these changes?');
	var b1 = {'action': _performNoteSave, 'title': 'Save'};
	var b2 = {'action': function(){_closeUnsavedNoteWarning(alert);}, 'title': 'Close'};
	var arr = new Array(b1, b2);
	alert.setButtons(arr);
	alert.show();
}

function _closeUnsavedNoteWarning (e) {
	e.close();
	_loadnote();
}

function _performNoteSave (e) {
	document.content.submit();
}

function _loadnote()
{	
	request = new AsyncRequest();
	request.action = function(a, req) { _notereceived(a, request, _notetitle) };
	request.fetch('/notes/fetch/' + _notetitle);
	// request.onload = function(a) { _notereceived(a, request, _notetitle); };
	// request.open("GET", '/notes/fetch/' + _notetitle);
	// request.send(null);
	_notechanged = false;
}

function _notereceived (e, request, title) {
	document.content.text.value = request.request.responseText;
	document.content.filename.value = title;
	document.title = title;
	NotesResizeTextArea();
}

function NotesResizeTextArea () {
	// "Grow" the textarea
	var ta = document.getElementsByTagName('textarea')[0];
	if (ta.style.height == '')
	{
		if (navigator.userAgent.indexOf('iPhone') > -1) 
		{	// Give a bit more room to iPhone users
			var h = 1;
			var val = window.setInterval(function() {
				if (h < 20)
				{
					h++;
					ta.style.height = h + 'em';
				}
				else
				{
					window.clearInterval(val);
				}
			}, 20);
		}
		else
		{
			var h = window.innerHeight - ta.offsetTop - 20;
			var idx = ta.offsetHeight;
			var val = window.setInterval(function() {
				if (ta.offsetHeight > h) 
				{
					ta.style.height = h + 'px';
					window.clearInterval(val);
				}
				else
				{
					idx += 20;
					ta.style.height = idx + 'px';
				}
			}, 10);
		}
	}
}

addEvent(window, 'load', _notesinit);
//window.addEventListener('load', _notesinit, ,false);